#ifndef	__AutoGame_h__
#define	__AutoGame_h__

#ifndef	_CRT_SECURE_NO_DEPRECATE
#define	_CRT_SECURE_NO_DEPRECATE
#endif

#include "game.h"
#include "irensei_ai_descripter.h"
#include <string>
#include <iostream>
#include <fstream>
#include <sstream>

class AutoGame:Irensei::Game{
public:
	static const int BlackIndex = 0;
	static const int WhiteIndex = 1;
private:
/*
	struct _tagIrenseiAI{
		struct FuncTable{
			int (*IrenseiInitialize)(const IRENSEI_RULE_DESCRIPTION*,int,int);
			int (*IrenseiFinalize)(int,int);
			int (*IrenseiThink)(int,IRENSEI_BOARD_POSITION*,const IRENSEI_BOARD_POSITION*,int);
		} mFuncTable;

		std::string mAiName;
		HMODULE mAiHandle;
	} IrenseiAI[2];
*/
	struct FuncTable{
		int (*IrenseiInitialize)(const IRENSEI_RULE_DESCRIPTION*,int,int);
		int (*IrenseiFinalize)(int,int);
		int (*IrenseiThink)(int,IRENSEI_BOARD_POSITION*,const IRENSEI_BOARD_POSITION*,int);
	} mFuncTable[2];

	std::string mBlackName, mWhiteName, mDirPath;
	HMODULE mBlackHandle, mWhiteHandle;

	bool mOutputKifu;
	int mPlayTimes;
	int mBlackWins, mWhiteWins;
	IRENSEI_RULE_DESCRIPTION rule;

	bool LoadAI(HMODULE &handle, std::string &fliename, FuncTable &funcTable);
	void PlayOneGame(int param1, int param2);

	bool LoadAllAI(){
		return LoadAI(mBlackHandle, mBlackName, mFuncTable[0]) &&
			LoadAI(mWhiteHandle, mWhiteName, mFuncTable[1]);
	}

	void ReleaseAI(){
		if(mBlackHandle){
			FreeLibrary(mBlackHandle);
			mBlackHandle = 0;
		}
		if(mWhiteHandle){
			FreeLibrary(mWhiteHandle);
			mWhiteHandle = 0;
		}
	}

public:
	void OutputKifu(int n);
	void PlayGame();

	AutoGame(char *black, char *white, int playTimes, bool out, char *dir)
		:mBlackName(black),mWhiteName(white),mPlayTimes(playTimes),mOutputKifu(out),mDirPath(dir){
		mBlackHandle = mWhiteHandle = 0;

		strcpy(rule.signature,"IRDESC!");
		rule.version = 100;
		rule.lineLength = 7;
		rule.outerInvalidLines = 2;
		rule.requiredLines = 1;
	}

	~AutoGame(){
		ReleaseAI();
	}

	bool Initialize(){
		return LoadAllAI();
	}

};
#endif

