#ifndef BOARD_H_INCLUDED
#define BOARD_H_INCLUDED

#ifdef _cplusplus
extern "C"{
#endif

/*
PȂf[^B
W͂On܂B

EStone rbgŒ`Ă闝ŔA~(EStone)mystone & Get(x,y) ̂悤ɔł悤ɂ邽߁B
ɂARFȂǂłCsvB
*/


#include <memory.h>


namespace Irensei {


class Board
{
public:
	Board()							{ Clear(); }
	Board( const Board & other )	{ memcpy( board, other.board, sizeof(board) ); }

	void Clear()	{ memset( board, 0, sizeof(board) ); }		// Ֆʂ̃NA

	enum EStone {
		EStoneSpace = 0,
		EStoneBlack = 1<<0,
		EStoneWhite = 1<<1,
		EStoneOutOfBounds = -1
	};
	
	EStone Get( int x, int y ) const	{ 
		if ( checkBounds(x,y) ) 
			return EStoneOutOfBounds;
		return board[y][x];
	}
	void AddBlack( int x, int y );		// @@@not implemented
	void AddWhite( int x, int y );		// @@@not implemented
	bool ChangeStone( int x, int y, EStone stone ) {	// Ԃ
		if ( checkBounds(x,y) && stone != EStoneOutOfBounds )
			return false;
		board[ y ][ x ] = stone;
		return true;
	}

	static const int MaxX = 19;
	static const int MaxY = 19;
private:
	EStone board[ MaxY ][ MaxX ];

	bool checkBounds( int x, int y) const {
		if ( x < 0 || y < 0 )
			return true;
		if ( MaxX <= x || MaxY <= y )
			return true;
		return false;
	}
};



}	// Irensei


#ifdef _cplusplus
}
#endif

#endif

