#include "StringData.h"
#include <memory.h>

namespace Irensei {


StringData::StringData()
{
	memset( pos2stringTable, -1, sizeof(pos2stringTable) );
}
StringData::StringData( const Board * board )
{
	Remake( board );
}

void StringData::Remake( const Board * board )
{
	strings.clear();
	memset( pos2stringTable, -1, sizeof(pos2stringTable) );

	int nextidx = 0;
	for ( int x = 0; Board::MaxX > x; x++ ) {
		for ( int y = 0; Board::MaxY > y; y++ ) {
			Board::EStone stone = board->Get( x, y );
			// ΂Ύ
			if ( stone == Board::EStoneSpace || stone == Board::EStoneOutOfBounds )
				continue;
			// ׂƂΎ
			if ( pos2stringTable[ y ][ x ] != -1 )
				continue;
			String string;
			string.idx = nextidx++;
			string.color = stone;
			MakeString( string, pos2stringTable, board, x, y );
			strings.push_back( string );
		}
	}
}


void StringData::MakeString( 
	String & string, 										// óBA
	int pos2stringTable[ Board::MaxY ][ Board::MaxX ], 		// óBς݂̉ӏB -1 Ŗ߂Ă
	const Board * board, int x, int y
)
{
	Board::EStone stone = board->Get( x, y );
	Position here = Position( x, y );
	// ՊOȂA
	if ( stone == Board::EStoneOutOfBounds ) {
		return;
	}
	// ΂Όċz_ǉċA
	if ( stone == Board::EStoneSpace ) {
		string.breathPoints.insert( here );
		return;
	}
	// ႤFȂA
	if ( stone != string.color )
		return;
	// łɒׂƂȂA
	if ( string.stones.find( here ) != string.stones.end() )
		return;

	pos2stringTable[ y ][ x ] = string.idx;
	string.stones.insert( here );
	// ㉺EċAIɒׂ
	MakeString( string, pos2stringTable, board, x-1, y   );
	MakeString( string, pos2stringTable, board, x+1, y   );
	MakeString( string, pos2stringTable, board, x,   y-1 );
	MakeString( string, pos2stringTable, board, x,   y+1 );
}



bool StringData::CheckSityou( const int x, const int y, const Board::EStone side ) const
{
	if ( pos2stringTable[ y ][ x ] != -1 )
		return false;		// ɂ͑łĂȂ

	// pos2stringTable Rs[Bƃobt@Ƃ
	int p2s[ Board::MaxX ][ Board::MaxY ];
	memcpy( p2s, pos2stringTable, sizeof(p2s) );

	// x, y ɑłāAstring ȂȂ
	{
		struct connect_string {
			int operator () ( 
				int p2s[ Board::MaxX ][ Board::MaxY ], 
				const std::vector< String > & strings,
				const int stidx, const int x, const int y, Board::EStone side
			) {
				if ( x < 0 || x >= Irensei::Board::MaxX || y < 0 || y >= Irensei::Board::MaxY )
					return stidx;
				const int id = p2s[y][x];
				if ( stidx < 0 ) {
					if ( id != -1 && strings[ id ].color == side )
						return id;
				}
				else {
					// x, y  string  stidx ɕύX
					if ( id != -1 && id != stidx && strings[ id ].color == side ) {
						for ( int lpc = 0; lpc < Irensei::Board::MaxX * Irensei::Board::MaxY; lpc++ ) {
							if ( p2s[0][ lpc ] == id )
								p2s[0][ lpc ] = stidx;
						}
					}
				}
				return stidx;
			}
		};

		p2s[y][x] = connect_string()( p2s, strings, -1,        x  , y-1, side );
		p2s[y][x] = connect_string()( p2s, strings, p2s[y][x], x  , y+1, side );
		p2s[y][x] = connect_string()( p2s, strings, p2s[y][x], x-1, y  , side );
		p2s[y][x] = connect_string()( p2s, strings, p2s[y][x], x+1, y  , side );
		if ( p2s[y][x] < 0 )
			return false;		// NƂqĂȂ̂ŃV`EȂɂȂ
	}

	// ȂȂV string ̃_𓾂
	{
		struct check_breath {
			int operator () ( 
				int p2s[ Board::MaxX ][ Board::MaxY ], 
				const int stidx, const int x, const int y, int cntBreath
			) {
				if ( x < 0 || x >= Irensei::Board::MaxX || y < 0 || y >= Irensei::Board::MaxY )
					return cntBreath;			// ՊO̓_Ȃ
				if ( p2s[y][x] == -1 ) {
					// _I
					p2s[y][x] = -2;					// ς
					return cntBreath + 1;
				}
				if ( p2s[y][x] != stidx )
					return cntBreath;
				p2s[y][x] = -2;					// ς
				// SɍċA
				cntBreath = check_breath()( p2s, stidx, x-1, y  , cntBreath );
				cntBreath = check_breath()( p2s, stidx, x+1, y  , cntBreath );
				cntBreath = check_breath()( p2s, stidx, x  , y-1, cntBreath );
				cntBreath = check_breath()( p2s, stidx, x  , y+1, cntBreath );
				return cntBreath;
			}
		};
		if ( 2 < check_breath()( p2s, p2s[y][x], x, y  , 0 ) )
			return false;		// _Q𒴂
	}

	return true;		// ǂ̔rȂ
}




}	// namespace Irensei


