#ifndef GAME_H_INCLUDED
#define GAME_H_INCLUDED

#ifdef _cplusplus
extern "C"{
#endif

/*
ՖʂA@𔻒fB
܂AԂoĂA̗ێB
*/

#include "irensei_rule_description.h"
#include "board.h"

#include <vector>

namespace Irensei {

class Game
{
public:
	Game();
	Game( const Game & other );
	explicit Game( const Board & orgBoard );		//@@@not implemented

	bool SetRule( const IRENSEI_RULE_DESCRIPTION & rule );		// Ԃ
	void Reset();							// ՖʂNAA̗p
	void Reset( const Board & orgBoard);	// Ֆʂ̏ԂɁA̗p
											//@@@not implemented

	enum EBlackOrWhite {
		EBWNone = 0,
		EBWBlack = 1<<0,
		EBWWhite = 1<<1,
		EBWBoth = EBWBlack | EBWWhite,
		EBWAll = -1
	};
	enum EMoveResult {
		EMResultOK,			// nj
		EMResultWin,		// VAŏ
		EMResultNonSpace,	// łɐ΂
		EMResultSuicide,	// E
		EMResultKou,		// 
		EMResultTooLong,	// A
	};

	struct Move {
		EBlackOrWhite blackOrWhite;
		int x;
		int y;
		int cntNuki;
		Move( EBlackOrWhite order, int a, int b, int c ) : blackOrWhite(order), x(a), y(b), cntNuki(c)	{};
	};

	EMoveResult NewMove( int x, int y );
	int CountMove( void ) const		{ return static_cast<int>(moves.size()); }
	Move GetMove( unsigned int idx ) const;		// O
	Move GetLastMove( void ) const	{ return GetMove( CountMove() - 1 ); };
	void Undo( void );

	EBlackOrWhite NextOrder( void ) const	{ return nextOrder; }
	static EBlackOrWhite NextOrder( EBlackOrWhite );

	EMoveResult CheckLegalMove( const Board * board, int x, int y, EBlackOrWhite order ) const;	// @Ȃ true


	static Board::EStone OrderToStone( EBlackOrWhite order )	// ۂ͌݊邯ǂ
	{
		if ( order == Game::EBWBlack )
			return Board::EStoneBlack;
		if ( order == Game::EBWWhite )
			return Board::EStoneWhite;
		return Board::EStoneSpace;
	}

private:
	const IRENSEI_RULE_DESCRIPTION rule;	// @@ SetRule() ̂ݏ

	EBlackOrWhite nextOrder;
	Board * board;
	int cntNuki;

	// Undo ̂߂̗
	struct Context {
/*
		Context( const Board & b, const Move & m ) : board(b), move(m)	{}
		Context( const Context & o ) : board(o.board),move(o.move)	{};
		const Context & operator=(const Context&o) { const_cast<Board&>(board)=o.board; move=o.move; return *this; }
*/
		Context( const Move & m ) : move(m)	{}
		Context( const Context & o ) : move(o.move)	{};
		const Context & operator=(const Context&o) { move=o.move; return *this; }
		//const Board board;
		Game::Move move;
	private:
		Context();
	};

	std::vector<Context> moves;


	// łグBグ΂̐Ԃ
	// x, y ȗƁAՖʑŜŒTBw肷ƁA̐΂̎ӂT
	static int killStones( Board* b, EBlackOrWhite order/*ǂ̐΂グ邩*/, int x = -1, int y = -1 );
};


}	// Irensei

#ifdef _cplusplus
}
#endif

#endif
